Mail::Message::TransferEnc(3pm)

NAME
Mail::Message::TransferEnc - message transfer encoder/decoder

INHERITANCE
 Mail::Message::TransferEnc
   is a Mail::Reporter

 Mail::Message::TransferEnc is extended by
   Mail::Message::TransferEnc::Base64
   Mail::Message::TransferEnc::Binary
   Mail::Message::TransferEnc::EightBit
   Mail::Message::TransferEnc::QuotedPrint
   Mail::Message::TransferEnc::SevenBit

SYNOPSIS
  my Mail::Message $msg = ...;
  my $decoded = $msg->decoded;
  my $encoded = $msg->encode(transfer => 'base64');

DESCRIPTION
This class is the base for various encoders and decoders, which are used during transport of the message. These packages, and all which are derived, are invoked by the message's Mail::Message::decoded() and Mail::Message::encode() methods:

  my $message = $folder->message(3);
  my $decoded_body = $message->decoded;
  my $encoded_body = $message->encode(transfer => 'base64');

Rules for transfer encodings are specified in RFC4289. The full list of permissible content transfer encodings can be found at <https://www.iana.org/assignments/transfer-encodings/transfer-encodings.xhtml>

The following coders/decoders are currently supported (April 2025, the full list at IANA):

•   Mail::Message::TransferEnc::Base64

    "base64" for binary information.

•   Mail::Message::TransferEnc::SevenBit

    "7bit" for plain old ASCII characters only.

•   Mail::Message::TransferEnc::EightBit

    "8bit" for extended character set data, not encoded.

•   Mail::Message::TransferEnc::QuotedPrint

    "quoted-printable" encdoded extended character set data.

Extends "DESCRIPTION" in Mail::Reporter.

METHODS
Extends "METHODS" in Mail::Reporter.

  Constructors
Extends "Constructors" in Mail::Reporter.

$class->new(%options)
    Inherited, see "Constructors" in Mail::Reporter

  Attributes
Extends "Attributes" in Mail::Reporter.

  The Encoder

$class->addTransferEncoder($type, $class)
    Adds one new encoder to the list known by the Mail::Box suite. The $type is found in the message's header in the "Content-Transfer-Encoding" field.

$obj->create($type, %options)
    Create a new coder/decoder based on the required type.

$obj->name()
    The name of the encoder. Case is not significant.

  Encoding

$obj->check($body, %options)
    Check whether the body is correctly encoded. If so, the body reference is returned with the "checked" flag set. Otherwise, a new object is created and returned.

     -Option     --Default
      result_type  <type of source body>

    result_type => CLASS
        The type of the body to be produced, when the checker decides to return modified data.

$obj->decode($body, %options)
    Use the encoder to decode the content of $body. A new body is returned.

     -Option     --Default
      result_type  <type of source body>

    result_type => CLASS
        The type of the body to be produced, when the decoder decides to return modified data.

$obj->encode($body, %options)
    Use the encoder to encode the content of $body.

     -Option     --Default
      result_type  <type of source body>

    result_type => CLASS
        The type of the body to be produced, when the decoder decides to return modified data.

  Error handling
Extends "Error handling" in Mail::Reporter.

$obj->AUTOLOAD()
    Inherited, see "Error handling" in Mail::Reporter

$obj->notImplemented()
    Inherited, see "Error handling" in Mail::Reporter

  Cleanup
Extends "Cleanup" in Mail::Reporter.

$obj->DESTROY()
    Inherited, see "Cleanup" in Mail::Reporter

DIAGNOSTICS

Error: class $package does not implement method $method.
    Fatal error: the specific $package (or one of its superclasses) does not implement this method where it should. This message means that some other related classes do implement this method however the class at hand does not. Probably you should investigate this and probably inform the author of the package. Cast by notImplemented()

Error: decoder for transfer encoding $type does not work: $@
    Compiling the required transfer encoding resulted in errors, which means that the decoder can not be used. Cast by create()

Error: no decoder for transfer encoding $type.
    A decoder for the specified type of transfer encoding is not implemented. Cast by create()

SEE ALSO
This module is part of Mail-Message version 4.03, built on January 26, 2026. Website: http://perl.overmeer.net/CPAN/

LICENSE
For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.